clear all
close all

ta=20;  % TWT to anomaly (ms)
tmax=500; % max time for plot (ms)
dt=15;  % (ms)
hmax=500; % max half offset (m)
dh=20; %sampling of plot surface in half offset (m)
ma=0; % midpoint of anomaly (m)
nm=50; %number of points for plot surface in midpoint

% number of points in output
nh=1+floor(hmax/dh);
nt=1+floor((tmax-ta)/dt);

h_coord=zeros(nh,nt);
m1_coord=zeros(nh,nt);
m2_coord=zeros(nh,nt);
t_coord=zeros(nh,nt);

for ih=0:nh-1
    h=ih*dh;
    h_coord(ih+1,:)=h;
    for it=0:nt-1
	t=ta+it*dt;
	t_coord(ih+1,it+1)=t;
	halfw=(1-ta/t)*h; %half width of Kjartansson V
	m1_coord(ih+1,it+1)=ma-halfw;
	m2_coord(ih+1,it+1)=ma+halfw;
    end
end

figure;

subplot(1,2,1)
% plot the constant-offset lines
 for ih=1:nh   
    for it=1:nt-1
	line([m1_coord(ih,it) m1_coord(ih,it+1)],[h_coord(ih,it) h_coord(ih,it+1)], [t_coord(ih,it) t_coord(ih,it+1)]); hold on
	line([m2_coord(ih,it) m2_coord(ih,it+1)],[h_coord(ih,it) h_coord(ih,it+1)], [t_coord(ih,it) t_coord(ih,it+1)]); hold on
    end	
end
   
% plot the constant-time lines
for it=0:nt-1
    t=ta+it*dt;
    halfw_max=(1-ta/t)*hmax; %max half width of Kjartansson V
    line([ma ma-halfw_max],[0 hmax],[t t]); hold on
    line([ma ma+halfw_max],[0 hmax],[t t]); hold on
end


set(gca,'ZDir','reverse')
grid on
%axis tight
view(70,-20)
xlabel('MIDPOINT(m)')
ylabel('HALF OFFSET(m)')
zlabel('TIME(ms)')
axis equal

% this is cut-and past of subplot above, different view:
subplot(1,2,2)
% plot the constant-offset lines
 for ih=1:nh   
    for it=1:nt-1
	line([m1_coord(ih,it) m1_coord(ih,it+1)],[h_coord(ih,it) h_coord(ih,it+1)], [t_coord(ih,it) t_coord(ih,it+1)]); hold on
	line([m2_coord(ih,it) m2_coord(ih,it+1)],[h_coord(ih,it) h_coord(ih,it+1)], [t_coord(ih,it) t_coord(ih,it+1)]); hold on
    end	
end
   
% plot the constant-time lines
for it=0:nt-1
    t=ta+it*dt;
    halfw_max=(1-ta/t)*hmax; %max half width of Kjartansson V
    line([ma ma-halfw_max],[0 hmax],[t t]); hold on
    line([ma ma+halfw_max],[0 hmax],[t t]); hold on
end


set(gca,'ZDir','reverse')
grid on
%axis tight
view(150,-10)
xlabel('MIDPOINT(m)')
ylabel('HALF OFFSET(m)')
zlabel('TIME(ms)')
axis equal
