clear all

za=20;  % depth to anomaly (m)
zmax=500;%100; % max depth for plot (m)
dz=12.5;  % (m)
amax=45; % max angle (degrees)
da=1.40625000000000;  %sampling of plot surface in angle (deg)
ma=0; % midpoint of anomaly (m)
nm=50; %number of points for plot surface in midpoint

% number of points in output
na=1+floor(amax/da);
nz=1+floor((zmax-za)/dz);

% initialize arrays to speed for loops
a_coord=zeros(na,nz);
m1_coord=zeros(na,nz);
m2_coord=zeros(na,nz);
z_coord=zeros(na,nz);

for ia=0:na-1
    a=ia*da;
    a_coord(ia+1,:)=a;
    for iz=0:nz-1
	z=za+iz*dz;
	z_coord(ia+1,iz+1)=z;
	halfw=(z-za)*tan(deg2rad(a)); %half width of Kjartansson V
	m1_coord(ia+1,iz+1)=ma-halfw;
	m2_coord(ia+1,iz+1)=ma+halfw;
    end
end

figure;
%subplot(1,2,1)

% plot the constant-angle lines
for ia=1:na   
    line([ma m1_coord(ia,nz)],[a_coord(ia,1) a_coord(ia,1)], [za zmax]); hold on
    line([ma m2_coord(ia,nz)],[a_coord(ia,1) a_coord(ia,1)], [za zmax]); hold on
end
   
% plot the constant-depth lines
for ia=1:na-1  
    for iz=1:nz
	line([m1_coord(ia,iz) m1_coord(ia+1,iz)],[a_coord(ia,iz) a_coord(ia+1,iz)], [z_coord(ia,iz) z_coord(ia+1,iz)]); hold on
	line([m2_coord(ia,iz) m2_coord(ia+1,iz)],[a_coord(ia,iz) a_coord(ia+1,iz)], [z_coord(ia,iz) z_coord(ia+1,iz)]); hold on
    end	
end
   

set(gca,'ZDir','reverse')
grid on
axis tight
view(40,-20)
xlabel('MIDPOINT(m)')
ylabel('ANGLE(deg)')
zlabel('DEPTH(m)')
