program Fkfilter

  use sep
  use fft_data_mod
  use fkfilter_mod
  implicit none

  logical:: fkout
  integer:: nt, nw, nh, ny, iy, ih, a, b, i
  real   :: ot, ow, oh, ok, dt, dw, dh, dk, vmin, eps
  real   ,  dimension(:)  , allocatable :: k
  real   ,  dimension(:,:), allocatable :: r !real plane (t,h)
  complex,  dimension(:,:), allocatable :: c !complex plane (w,h)
  type(fft_type)                        :: rfft_1d_id, fft_1d_id

  call sep_init ()
  call from_param("fkout", fkout, .false.)
  call from_param("vmin" , vmin ,   1.7)
  if (vmin==0) call seperr('vmin cannot be zero')
  call from_param("eps"  , eps  ,  20.   )

  call from_history("n1", nt, 2500 )
  call from_history("o1", ot,    0.)
  call from_history("d1", dt,    1.)

  nw=nt/2+1
  ow=0.
  dw=1/(dt*real(nt))

  call from_history("n2", nh,   48) 
  call from_history("o2", oh, 0.)
  call from_history("d2", dh, 1.)

  allocate(k(nh))
  k=build_fspace(dh,nh)
  ok=k(1)
  dk=k(2)-k(1)
  
  if(fkout) then
     call to_history("esize",8)
     call to_history("n1",  nw)
     call to_history("o1",  ow)
     call to_history("d1",  dw)
     call to_history("o2",  ok)
     call to_history("d2",  dk)
     call to_history("label1","f[1/s]")
     call to_history("label2","k[1/km]")
  end if

  call from_history("n3", ny,  428)

  call sep_close ()  

  eps = eps*nh*dk/(48.*0.416667)
  rfft_1d_id = init_rfft_1d(nt)
  fft_1d_id = init_fft_1d(nh)
  allocate(r(nt,nh),c(nw,nh)); r=0.; c=0.

  shots:do iy=1,ny
     call sep_read(r) 
     call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,nt,r(:,1),c(:,1))
     do ih=2,36
        call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,nt,r(:,ih),c(:,ih))
     end do
     if(nh<38) call seperr("too few offsets")
     do ih=38,nh 
        call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,nt,r(:,ih),c(:,ih))
     end do

     !Notch filter
     call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,nt,r(:,2),c(:,2))
     call cmpxlinterp(c(:,2),298,303) !60 Hz
     call cmpxlinterp(c(:,2),593,607) !120 Hz

     call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,nt,r(:,37),c(:,37))
     call cmpxlinterp(c(:,37),298,303) !60 Hz

     call kfilter(c,vmin,eps,dw,k,fft_1d_id)

     if(fkout) then
        call sep_write(c)
     else
        do i=1,nw
           call fft_1d_data(fft_1d_id,FFTW_BACKWARD, nh, c(i,:))
        end do
        do ih=1,nh
           call rfft_1d_data(rfft_1d_id,FFTW_COMPLEX_TO_REAL,nt,r(:,ih),c(:,ih))
        end do
        call sep_write(r)
     end if
  end do shots

  deallocate(r,c,k)
  call clean_fft(fft_1d_id)
  call clean_rfft(rfft_1d_id)
end program Fkfilter


