program Amo
  use sep
  use amo_logstretch_mod
  use amo_types_mod

  implicit none
  type(amo_param_type)                   :: p
  real,    allocatable, dimension(:,:,:) :: realcube
  complex, allocatable, dimension(:,:,:) :: cmpxcube
  integer                                :: n1_cmpxcube

  call sep_init(SOURCE)

  call from_history("n1",p%n(1))
  call from_history("n2",p%n(2))
  call from_history("n3",p%n(3))

  call from_history("o1",p%o(1))
  call from_history("o2",p%o(2))
  call from_history("o3",p%o(3))
 
  call from_history("d1",p%d(1))
  call from_history("d2",p%d(2))
  call from_history("d3",p%d(3))

  call to_history("n1",p%n(1))
  call to_history("n2",p%n(2))
  call to_history("n3",p%n(3))

  call to_history("o1",p%o(1))
  call to_history("o2",p%o(2))
  call to_history("o3",p%o(3))

  call to_history("d1",p%d(1))
  call to_history("d2",p%d(2))
  call to_history("d3",p%d(3))

  call from_param("H1x"        ,p%hx_inp     )
  call from_param("H1y"        ,p%hy_inp     )
  call from_param("H2x"        ,p%hx_out     )
  call from_param("H2y"        ,p%hy_out     )

  call from_param("t_min_log"  ,p%t_min_log  )
  call from_param("fk_filter"  ,p%fk_filter  )
  call from_param("v_min"      ,p%v_min      )
  call from_param("f_max"      ,p%f_max      )

  call sep_close()

  allocate(realcube(p%n(1),p%n(2),p%n(3))) 
     call sep_read(realcube)
     call init_amo_logstretch(p)
     allocate(cmpxcube(p%n1_cmpxcube,p%n(2),p%n(3)))
        p%fft_xy_forw=.true.; p%amo=.true.; p%fft_xy_back=.true.
        call amo_logstretch(p,realcube,cmpxcube)
!       If you want to do other things in the log-stretch, FFT domain
!       Replace the two lines above by something like that:
!          ! Apply log-stretch and 3D FFT to realcube => compute cmpxcube:
!          p%fft_xy_forw=1; p%amo=0; p%fft_xy_back=0
!          call amo_logstretch(p,realcube,cmpxcube)
!          Do something here to cmpxcube
!          ! If you want, do AMO too: 
!          p%fft_xy_forw=0; p%amo=1; p%fft_xy_back=0
!          call amo_logstretch(p,realcube,cmpxcube)
!          ! Go back to the (cmp_x,cmp_y,time) domain:
!          p%fft_xy_forw=0; p%amo=0; p%fft_xy_back=1
!          call amo_logstretch(p,realcube,cmpxcube)
     deallocate(cmpxcube)
     call clean_amo_logstretch
     call sep_write(realcube)
  deallocate(realcube)

  call exit(0) 
end program Amo
