program Sh2yh
  ! Transforms a 2D survey from (s,h) coordinates to (y,h) coordinates
  ! Offset: h=(s-g)/2 (opposite sign than in BEI!). Midpoint: y=(s+g)/2
  ! Input:  (s,h,t) cube obtained from (t,h,s) cube Transp plane=13. 
  ! Output: (y,h,t) cube. (CMP gathers) Transp plane=13 to get (t,h,y) cube
  use sep
  implicit none

  integer:: nt, ns, ny, nh, t, i
  real   :: oy, dy
  real   ,  dimension(:), allocatable :: y
 
  call sep_init ()

  call from_history("n1", ns, 1)
  call from_history("n2", nh, 1)
  call from_history("n3", nt, 1)

  ny = ns + nh - 1

  call to_history("n1", ny)

  call from_history("oy", oy)
  call from_history("dy", dy)
  call to_history  ("o1", oy)
  call to_history  ("d1", dy)

  call to_history("label1", "midpoint (km)")
  call sep_close ()  

  allocate(y(ny)); y=0.
  time:do t = 1, nt
     offset:do i=1,nh
        y=0.; call sep_read(y(:ns))
        y(nh-i+1:ny-i+1)=y(:ns)
        y(:nh-i)=0.
        call sep_write(y) 
     end do offset
  end do time
  deallocate(y)

end program Sh2yh
