program Yh2sh
  ! Transforms a 2D survey from (y,h) coordinates to (s,h) coordinates
  ! Offset: h=(s-g)/2 (opposite sign than in BEI!). Midpoint: y=(s+g)/2
  ! Input:  (y,h,t) cube obtained from (t,h,y) cube Transp plane=13. 
  ! Output: (s,h,t) cube. (Shot gathers) Transp plane=13 to get (t,h,s) cube
  use sep
  implicit none

  integer:: nt, ns, ny, nh, t, i
  real   :: oy, dy
  real   ,  dimension(:), allocatable :: y
 
  call sep_init ()

  call from_history("n1", ny, 1)
  call from_history("o1", oy, 1.)
  call from_history("d1", dy, 1.)

  call from_history("n2", nh, 1)
  call from_history("n3", nt, 1)

  ns = ny - nh + 1

  call to_history("n1", ns)
  call to_history("o1", 1.)
  call to_history("d1", 1.)
  call to_history("label1", "shot #")

  call to_history("oy", oy)
  call to_history("dy", dy)

  call sep_close ()  

  allocate(y(ny)); y=0.
  time:do t = 1, nt
     offset:do i=1,nh
        call sep_read(y)
        y(:ns)=y(nh-i+1:ny-i+1)
        call sep_write(y(:ns)) 
     end do offset
  end do time
  deallocate(y)

end program Yh2sh
