program ExtractFEAVO
  ! Extract Focusing-Effect AVO from angle gathers
  ! Input: Dimension 1 must be angle. Dim2,3 must be midpoint/depth
  use sep, only: sep_init, sep_close, sep_read, sep_write, from_history

  implicit none
  real, dimension (:) :: t
  integer             :: n1, n2, n3, i

  call sep_init()
  call from_history('n1', n1)
  call from_history('n2', n2)
  call from_history('n3', n3)
  call sep_close()

  allocate(t(n1)); t=0

  do i=1,n2*n3
     call sep_read (t)
     write(7,*) 'Before subtraction', sum(t)
     t=t-sum(t)/n1
     write(7,*) 'After            .', sum(t)
     call sep_write(t)
  end do
  
  deallocate(t)
end program ExtractFEAVO
