clear all

x = [1300 1350 1400 1550 1600 1650];
j = [17 22 27 42 47 52];

w=sread('p1_slice.H');
y = [w.o(1) w.o(1)+w.d(1)*(w.n(1)-1)];
a = sin((y(1):w.d(1):y(2))*pi/180).^2;

subplot(3,3,1:3)
	imagesc([w.o(2) w.o(2)+w.d(2)*(w.n(2)-1)],y,w.data)
	colormap(gray)
	xlabel('midpoint[m]') 
	ylabel('angle[deg]')
	title('{\bf FEAVO anomalies in depth slice, prestack migrated angle}')
	for i=1:length(x)
	    hold on
	    line([x(i) x(i)],y)
	end

for i=1:length(x)
    subplot(3,3,3+i)
    plot(a,w.data(:,j(i))*10^6,'k')
    axis([0 0.25 -4 6]) 
    xlabel('sin^2(angle)')
    ylabel('amplitude')
    title(cat(2,'{\bf midpoint: ',num2str(x(i)),' m}'))
end

set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'inches');
set(gcf, 'PaperPosition', [0.25 0.25 7.5 10.5]);