MAKE_DEPEND=yes
SAVE_FORTRAN=yes

SRCDIR = ./src
LIBDIR = ${PCSDIR}/lib
INCDIR = .#${PCSDIR}/inc
BINDIR = ${PCSDIR}/bin
OBJDIR = ${PCSDIR}/obj
PARDIR = ./par

S = ${SRCDIR}
I = ${INCDIR}
B = ${BINDIR}
O = ${OBJDIR}
P = ${PARDIR}
#----------------------------------------------------------------
# COMPILER FLAGSs	
ifeq (${SEP_ARCH},LINUX)
  F90C   = pgf90 -mp 
  F90LD  = pgf90 -mp 
  MPIDIR = /usr/local/MPI/MPI-1.2.5/lib
else
  F90C   = ifc_f90 -openmp
  F90LD  = ifc_f90 -openmp
  MPIDIR = /net/okok/cluster/mpi/lib
endif
UF90FLAGS= -O2   -mp #-Mbounds
#----------------------------------------------------------------
#FFTLIB = -L/net/koko/bob/FFTW/lib/ -lfftw -lrfftw \
#	 -L/net/koko/biondo/FFTW/$(SEP_ARCH)/lib/ -lsfftw

FFTLIB = -L/net/koko/paul/fftw2/lib/ -lfftw -lrfftw 

MPILIB = -L${MPIDIR} 	-lmpichf90 -lfmpich -lmpich
#SEPLIB =        /usr/local/SEP6.1/lib/libsepmpif90.a       \
#		/usr/local/SEP6.1/lib/libsepmpi.a          \
#	-lsuperset -lsep2df90 -lsep3df90 -lsep3d -lsepf90 -lsep
SEPLIB = -lsepmpif90 -lsepmpi \
	-lsuperset -lsep2df90 -lsep3df90 -lsep3d -lsepf90 -lsep
#----------------------------------------------------------------
UF90INCLUDES = -I. -I${INCDIR}
UF90LIBS     = ${FFTLIB} ${SEPLIB} ${MPILIB} -Bstatic
#----------------------------------------------------------------
UF90LIBDIR   = ${F90_LIB_DIR}
UF90LIBDIRS  =   ${LIBDIR}
UCLIBDIRS    =   ${LIBDIR}
#----------------------------------------------------------------
# archive rules
date=.$(shell date +%m).$(shell date +%d).$(shell date +%Y)
backup: 
	\cp -r $S archive/$S${date}
#----------------------------------------------------------------

fgh:
	@-echo $(date)
