/*<
3drv

DESCRIPTION
3-D ray visualization 
    for rays generated by hwt3d

USAGE
< hwt3drays.H 3drv.x par= > /dev/null

INPUT  PARAMETERS
zoom       - int [2]   initial zoom
usecolor   - [y]/n     plot rays in color or b/w
rays       - [y]/n     plot rays
wavefronts - [y]/n     plot wavefronts

CONTROL KEYS
y/Y        - rotate object around the vertical axis
u/d        - move camera Up/Down
i/o        - move camera In/Out
r          - togle On/Off rays
w          - togle On/Off wavefronts
a          - display wavefront at a given aperture
c          - display a 'cone' of rays for a given shooting inclination
q          - togle On/Off the 'one-ray' display
][         - move wavefront forward/backward  in time
}{         - change inclination for the 'one-ray'
)(         - change azimuth for the 'one-ray'
ESC        - end

AUTHOR
Paul Sava - SEP 1998

>*/

#include "3drv.h"

MAIN()
{

  fprintf(stderr,"read data       "); read_cube(4);      fprintf(stderr," OK \n");	
  fprintf(stderr,"read parameters "); read_parameters(); fprintf(stderr," OK \n");

  prepare_i();
  graph();
  
  return 0;
}
