#include "3drviosetup.h"

void read_parameters(void)
{
  if(0==getch("view_angle","f",&view_angle))     view_angle=0;
  else view_angle*=PI/180;

  if(0==getch("zoom","f",&zoom))             zoom=1;
  if(0==getch("rays","1",&rays))             rays=YES;
  if(0==getch("wavefronts","1",&wavefronts)) wavefronts=YES;
  if(0==getch("wft","f",&wft))               wft=0;
  if(0==getch("aperture","1",&aperture))     aperture=YES;
  if(0==getch("cone","1",&cone))             cone=NO;
  if(0==getch("apt","f",&apt))               apt=1;
  if(0==getch("oneray","1",&oneray))         oneray=YES;
  if(0==getch("ray","f",&ray))               ray=1;
  if(0==getch("usecolor","1",&usecolor))     usecolor=1;

  if(0==hetch("nt1","d",&nt1)) seperr("can't get nt1\n");
  if(0==hetch("nt2","d",&nt2)) seperr("can't get nt2\n");
  if(0==hetch("nt3","d",&nt3)) seperr("can't get nt3\n");
/*  if(0==getch("nt4","d",&nt4)) seperr("can't get nt4\n");*/

  if(0==hetch("ot1","f",&ot1)) seperr("can't get ot1\n");
  if(0==hetch("ot2","f",&ot2)) seperr("can't get ot2\n");
  if(0==hetch("ot3","f",&ot3)) seperr("can't get ot3\n");
/*  if(0==getch("ot4","f",&ot4)) seperr("can't get ot4\n"); */

  if(0==hetch("dt1","f",&dt1)) seperr("can't get dt1\n");
  if(0==hetch("dt2","f",&dt2)) seperr("can't get dt2\n");
  if(0==hetch("dt3","f",&dt3)) seperr("can't get dt3\n");
/*  if(0==getch("dt4","f",&dt4)) seperr("can't get dt4\n"); */
}

void prepare_i(void)
{
  int idata=0;
  
  /* set input data */
  na=nin[0]; oa=oin[0]; sa=din[0];
  nr=nin[1]; or=oin[1]; sr=din[1];
  nt=nin[2]; ot=oin[2]; st=din[2];
  
  rap=(point3D***) malloc(na*sizeof(point3D**));
  for(ia=0;ia<na;ia++)
    rap[ia]=(point3D**) malloc(nr*sizeof(point3D*));
  for(ia=0;ia<na;ia++)
    for(ir=0;ir<nr;ir++)
      rap[ia][ir]=(point3D*) malloc(nt*sizeof(point3D));
  
  for(ia=0;ia<na;ia++)
    for(ir=0;ir<nr;ir++)
      for(it=0;it<nt;it++) {
	rap[ia][ir][it].x=datain[idata++];
	rap[ia][ir][it].y=datain[idata++];
	rap[ia][ir][it].z=datain[idata++];
      }

  xmin=ot2; xmax=ot2+nt2*dt2;
  ymin=ot3; ymax=ot3+nt3*dt3;
  zmin=ot1; zmax=ot1+nt1*dt1;
}

void prepare_o(void)
{
}

void write_parameters(void)
{
}


