#include<stdio.h>
#include<seplib.h>
#include<string.h>

main(int argc, char **argv)
{
  int   N=10;
  int   n[N];
  float o[N];
  float d[N];
  int i,k;
  char buf[3];
  char inbin[8192];

  char label[N][10];
  char lbuf[7];

  int esize;
  double truesize,wantsize;
  double nelements;
  double factor;

  if(argc > 2) {
    printf("usage: %s file\n",argv[0]);
    exit(0);
  }

  initpar(argc,argv);

  if(0==auxpar("in","s",inbin,argv[1])){
    printf("not a header file\n");
    exit(0);
  }
  if(0==auxpar("esize","d",&esize,argv[1])) esize=4;

  nelements=1.0;
  factor=1.0;
  for(i=0;i<N;i++) {
    sprintf(buf,"n%d",i+1);
    if(0==auxpar(buf,"d",&n[i],argv[1])) n[i]=1;
    nelements *= n[i];

    sprintf(buf,"o%d",i+1);
    if(0==auxpar(buf,"f",&o[i],argv[1])) o[i]=0.;

    sprintf(buf,"d%d",i+1);
    if(0==auxpar(buf,"f",&d[i],argv[1])) d[i]=1.;

    sprintf(lbuf,"label%d",i+1);
    if(0==auxpar(lbuf,"s",&label[i],argv[1])) *label[i]=' ';
  }

  /* count the true number of axes */
  for(k=N;n[k-1]==1;k--) ;
  /* but add one more*/
  k++;

  /*  if(k<5) k=5;*/

  /*bytes*/
  truesize=1.0*1024*esize*ssize_block(argv[1],1024*esize);
  wantsize=         esize*nelements;
  /**/

  printf("\n");
  i=line(strlen(inbin)+4>65?strlen(inbin)+4:65);
  printf("%s\n",argv[1]);
  printf("in=%s\n",inbin);
  i=line(strlen(inbin)+4>65?strlen(inbin)+4:65);
  for(i=0;i<k;i++) {
    printf("n%d=%5d\t o%d=%4.6f\t  d%d=%4.6f\t %s\n",i+1,n[i],i+1,o[i],i+1,d[i],label[i]);
  }
  i=line(strlen(inbin)+4>65?strlen(inbin)+4:65);
  printf("        esize=%d   \n",esize);

  if(wantsize>=1024*1024*1024) {                     /*Gb*/
    printf("expected size=%.3f Gb\n"          ,wantsize/1024/1024/1024);
    printf("    true size=%.3f Gb (%.1f\%%)\n",truesize/1024/1024/1024,100.0*truesize/wantsize);
  } else if(wantsize>=1024*1024)                  {  /*Mb*/
    printf("expected size=%.3f Mb\n"          ,wantsize/1024/1024);
    printf("    true size=%.3f Mb (%.1f\%%)\n",truesize/1024/1024,     100.0*truesize/wantsize); 
  } else if(wantsize>=1024 && wantsize<1024*1024) {  /*Kb*/
    printf("expected size=%.3f Kb\n"          ,wantsize/1024);
    printf("    true size=%.3f Kb (%.1f\%%)\n",truesize/1024,          100.0*truesize/wantsize); 
  } else                                          {  /* b*/
    printf("expected size=%.0f bytes\n"          ,wantsize);
    printf("    true size=%.0f bytes (%.1f\%%)\n",truesize,            100.0*truesize/wantsize); 
  }
  i=line(strlen(inbin)+4>65?strlen(inbin)+4:65);
}


/* draw a horizontal line */
int line(int n)
{
  int i;
  if(n>79) n=79;

  for(i=0;i<n;i++) {
     printf("-");
  }
  printf("\n");
  return 0;
}



