program Vxz_
  use sep
  use util_

  implicit none
  type(myaxis)            :: ax,az
  real,    pointer        :: vel(:,:)
  real                    :: vo,gx,gz
  integer                 ::    ix,iz
  real                    ::    dx,dz

  call sep_init()

  ax%l="x"
  call pinaxis(ax)
  az%l="z"
  call pinaxis(az)

  call houaxis(az,1)
  call houaxis(ax,2)

  call to_history("esize",4)

  call from_param("vo",vo,1000.)
  call from_param("gx",gx,1.0)
  call from_param("gz",gz,1.0)
  call sep_close()

  allocate(vel(az%n,ax%n))

  do iz=1,az%n;    dz=(iz-1)*az%d
     do ix=1,ax%n; dx=(ix-1)*ax%d
        vel(iz,ix)= vo + gx*dx + gz*dz
     end do
  end do

  call sep_write(vel)

  call exit (0)
end program VXZ_




