#include "biohwt.h"

int read_cube(void)
{
  int iD=0;
  int esize;
  float* data;
  /*  FILE* auxf;*/
  
  if(0==hetch("esize","d",&esize)) esize=4;
  
  /* number of elements */
  if(0==hetch("n1","i",&nZ))  
    seperr("can not obtain n1 required for SEP datasets\n");
  if(0==hetch("n2","i",&nX))
    seperr("can not obtain n2 required for SEP datasets\n");
  
  /* origins */
  if(0==hetch("o1","f",&oZ))
    seperr("can not obtain o1 required for SEP datasets\n");
  if(0==hetch("o2","f",&oX))
    seperr("can not obtain o2 required for SEP datasets\n");
  
  /* steps */
  if(0==hetch("d1","f",&dZ))
    seperr("can not obtain d1 required for SEP datasets\n");
  if(0==hetch("d2","f",&dX))
    seperr("can not obtain d2 required for SEP datasets\n");
  
  Xmax=oX+(nX-1)*dX;
  Zmax=oZ+(nZ-1)*dZ;
  
  if(0==getch("xsou","f",&xsou))
    seperr("trouble obtaining xsou \n");
  
  if(0==getch("zsou","f",&zsou))
    seperr("trouble obtaining zsou \n");
  
  if(0==getch("nT","d",&nT))
    seperr("trouble obtaining nT \n");
  
  if(0==getch("nG","d",&nG))
    seperr("trouble obtaining nG \n");
  
  if(0==getch("oT","f",&oT))
    seperr("trouble obtaining oT \n");
  
  if(0==getch("oG","f",&oG))
    seperr("trouble obtaining oG \n");
  
  if(0==getch("dT","f",&dT))
    seperr("trouble obtaining dT \n");
  
  if(0==getch("dG","f",&dG))
    seperr("trouble obtaining dG \n");
    
  /*  auxf=auxin("boundary");*/
  /*  bound=(float*) malloc(2*2*nT*sizeof(float*)); */
  /*  sreed("boundary",bound,2*2*nT*sizeof(float*));*/
  
  V=(float**) malloc(nZ*sizeof(float*));
  for(iZ=0;iZ<nZ;iZ++)
    V[iZ]=(float*) malloc(nX*sizeof(float));
  
  /* allocate a dumb vector of floats */
  data=(float*) malloc(nZ*nX*sizeof(float));
  if(nZ*nX*esize != sreed("in", data , nZ*nX*esize))
    seperr("trouble reading in data \n");
  
  /* transfer data into the velocity matrix */
  for(iX=0;iX<nX;iX++)
    for(iZ=0;iZ<nZ;iZ++,iD++)
      V[iZ][iX]=data[iD];
  free(data);
  
  return 0;
}

int write_cube(void)
{
  float *rayout;
  int index;
  int es=8;
  
  rayout=(float *) malloc (2*nG*nT*sizeof(float));
  
  index=0;
  for(iG=0;iG<nG;iG++)
    {
      for(iT=0;iT<nT;iT++)
	{
	  rayout[index++]=p[iT][iG].x;
	  rayout[index++]=p[iT][iG].z;
	}
    }
  
  if(0!=putch("esize","d",&es))
    seperr("trouble putting esize into output history file. \n");
  
  if(0!=putch("n1","d",&nT))
    seperr("trouble putting n1 into output history file. \n");
  
  if(0!=putch("o1","f",&oT))
    seperr("trouble putting o1 into output history file. \n");
  
  if(0!=putch("d1","f",&dT))
    seperr("trouble putting d1 into output history file. \n");
  
  if(0!=putch("n2","d",&nG))
    seperr("trouble putting n2 into output history file. \n");
  
  if(0!=putch("o2","f",&oG))
    seperr("trouble putting o2 into output history file. \n");
  
  if(0!=putch("d2","f",&dG))
    seperr("trouble putting d2 into output history file. \n");
  
  index=nT*nG;
  if(index*es != srite("out", rayout, index*es))
    seperr("trouble writing output data \n");	
  
  free(rayout);
  hclose();
  return 0;
}








