/*<
Huygens wavefront tracing
>*/

#include "seplib.h"
#include "biohwt.h"
#include "globals.h"
#include "wftr.h"
#include <math.h>

void compute(void);
void init_wf(void);

#include<sep.main>
MAIN()
{
                fprintf(stderr,"read velocity");
  read_cube();	fprintf(stderr," OK \n");
                fprintf(stderr,"initialize wavefronts");
  init_wf();	fprintf(stderr," OK \n");
  
                fprintf(stderr,"compute wavefronts ");
  compute();    fprintf(stderr," OK \n");
  
                fprintf(stderr,"write rays");
  write_cube(); fprintf(stderr," OK \n");
  
  return 1;
}

void compute(void)
{
  point P1,P2,P3,Q;
  float dd;

  for(iT=1;iT<nT-1;iT++) {
    for(iG=1;iG<nG-1;iG++) {
      P1=p[iT  ][iG-1];
      P2=p[iT  ][iG  ];    /* current 'middle' point */
      P3=p[iT  ][iG+1];
      Q =p[iT-1][iG  ];    /* previous 'middle' point on the ray */
      
      dd=distance(P3,P1);

      /*      if (iT==250) fprintf(stderr,"iT=%d iG=%d (%d)\n",iT,iG,iscusp(Q,P1,P2,P3));*/

      if(iscusp(Q,P1,P2,P3))
	raytr(iT,iG);
      else
	wfttr(iT,iG);
    }}
}

void init_wf(void)
{
  p=(point**)malloc(nT*sizeof(point*));
  for(iT=0;iT<nT;iT++)
    p[iT]=(point*) malloc(nG*sizeof(point)); 
  
  /* set all (x,z) to (0,0) */
  for(iT=0;iT<nT;iT++) {
    for(iG=0;iG<nG;iG++) {
      p[iT][iG].x=0.0;
      p[iT][iG].z=0.0;
      p[iT][iG].v=0.0;
    }}

  /* set (x,z) for iT=0 to (xsou,zsou) */
  iT=0;
  for(iG=0;iG<nG;iG++) {
    fprintf(stderr,"");
    p[iT][iG].x=xsou;
    p[iT][iG].z=zsou;
    p[iT][iG].v=get_xz_velocity(p[iT][iG]);
  }

  /* set (x,z) for iT=1 to (D sin(angle),D cos(angle)) */
  iT=1;
  for(iG=0;iG<nG;iG++) {
    double angle=PI*(oG+iG*dG)/180;
    double D;
    double Vcur;
    
    Vcur=p[0][iG].v;
    D=dT*Vcur;
    
    p[iT][iG].x=xsou+D*sin(angle);
    p[iT][iG].z=zsou+D*cos(angle);
    p[iT][iG].v=get_xz_velocity(p[1][iG]);
  }

  /* set boundaries */
  for(iT=1;iT<nT-1;iT++) {
    raytr(iT,0);
    raytr(iT,nG-1);
  }
}















