/*<
hwt3d

DESCRIPTION
3-D ray tracing

USAGE
< velocity.H hwt3d.x par= > rays.H

INPUT  PARAMETERS
xshot - float 
yshot - float
zshot - float

aimi  - float  aim inclination; aimi=0 is along the positive z
aima  - float  aim azimuth;     aima=0 is along the positive x
                                 positive values rotate clockwise
oi    - float
ni    - int    number of steps for half aperture; 91 means 90 steps
si    - float  step in the inclination direction;
                (ni-1)*sa=max inclination angle
sa    - float  radial step
                na=number of azimuth steps is computed internally as na=360/sa
st    - float 
nt    - int 

AUTHOR
Paul Sava - SEP 1998

>*/

#include<sep.main>
#include "hwt_struct.h"
#include "hwt_output.h"
#include "basicio.h"
#include "hwtiosetup.h"
#include "hwt_alloct.h"
#include "hwt_wftsub.h"

MAIN()
{
  rays RR;
  cube VV;

  wr("----------------\n");
  wr("read data  V  "); read_cube(3);              wr("OK\n");
  wr("read par   V  "); readpar_velo(&VV);         wr("OK\n");
  wr("allocate   V  "); allocate_cube(&VV);        wr("OK\n");
  wr("set        V  "); set_cube(&VV,1500.0);      wr("OK\n");
  wr("copy       V  "); copy_velo(&VV);            wr("OK\n");
  wr("----------------\n");
  wr("read par   R  "); readpar_rays(&RR);         wr("OK\n");
  wr("allocate   R  "); allocate_rays(&RR);        wr("OK\n");
  wr("trace      R  "); tracerays(&RR,&VV);        wr("OK\n");
  wr("----------------\n");
  wr("write par  V  "); writepar_velo(&VV);        wr("OK\n");
  wr("----------------\n");
  wr("write par  R  "); writepar_rays(&RR);        wr("OK\n");
  wr("write data R  "); write_rays(&RR);           wr("OK\n");
  wr("----------------\n"); 	
  fprintf(stderr,"%dR         8) \n",RR.na*RR.ni);
  return 1;
}




