#include "hwt_3dmain.h"
#include "hwt_output.h"
#include "hwt_wftsub.h"
#include "hwt_intsub.h"
#include "hwt_alloct.h"
#include "hwt_global.h"

void tthw3d(rays *pRR, cube *pVV, cube *pTT, cube *pLL)
{
  triplets trp;
  tetrahedra tet;
  int fast=1;

  wr("set        T  "); set_cube(pTT,NOTIME);                    wr("OK\n");
  wr("set        L  "); set_cube(pLL,0.0);                       wr("OK\n");
  wr("----------------\n");
  wr("trace      R  "); tracerays(pRR,pVV);                      wr("OK\n");
  wr("measure    R  "); measure_rays(pRR);                       wr("OK\n");
  wr("tesselate ON  "); tesselate_init(pRR,&trp,&tet);           wr("OK\n");
  wr("tesselate     "); tesselate(pRR,&trp,&tet);                wr("OK\n");

  if (fast) {
    wr("interpolate F "); get_times_fast(pRR,&trp,&tet,pTT,pLL); wr("OK\n");
    wr("fill-up       "); median_filter(pTT,pLL);                wr("OK\n");
    wr("smooth        "); mean_filter(pTT,pLL);                  wr("OK\n");
  }
  else {
    wr("interpolate S "); get_times_slow(pRR,&trp,&tet,pTT,pLL); wr("OK\n");
  }
  wr("tesselate OFF "); tesselate_close(&trp,&tet);              wr("OK\n");
  wr("----------------\n");
}
