# Parameters to create the velocity model at page 385 in: Hatchell, P. J., 
# "Fault Whispers, Transmission distortions on prestack seismic reflection 
# data,"Geophysics, Vol 65, No. 2, pp. 377 - 389, March - April 2000.

# Input: v1, v2 and EITHER nx, nz, x1, x2, z1, z2, z3 (setsampling=n) 
#                   OR     dx, dz,nx1,nx2,nz1,nz2,nz3 (setsampling=y) 
# Output: (nz,nx) sized velocity model. 
# Parameters and vel model: described in the drawing below
#
# <--------x1--------><--------x2-------->
# ^                   
# |
# |
# |
# z1        v1                 v1
# |
# |
# |
# v
# ____________________
# ^                  |
# z2        v2       |         v1
# v                  |
# --------------------
# ^                   
# |
# |
# |
# z3        v1                 v1
# |
# |
# |
# v
#############################################################
v1=1830.
v2=1647.

setsampling=y
dx=12.
dz=12.

nx1=4096
nx2=4096
# original 256, 256
nz1=256
nz2=13
nz3=231
