program Mpat
! Measure Peak Amplitude in a Trace and its time location. Input: only 2D 
! files, if n3/=1 it will abort. Output will have:
! Row one: locations (time/depth, not sample number). Row 2: ampl values
  use sep
  use max_loc_and_val_mod
  implicit none

  integer:: nx, nt, n3, x
  real   :: ot, dt
  real   ,  dimension(:), allocatable :: trace
 
  call sep_init ()
  call from_history('n3', n3, 1)
  if(n3/=1) call seperr('Change source code to add a loop and a dim to output')

  call from_history('n1', nt, 1 )
  call from_history('o1', ot, 1.)
  call from_history('d1', dt, 1.)
  call from_history('n2', nx, 1 )

  call to_history('n1'    ,  2 )
  call to_history('o1'    ,  0.)
  call to_history('d1'    ,  0.)
  call to_history('label1', ' ')
  call sep_close ()  

  allocate(trace(nt)); trace=0.
  do x = 1, nx
     call sep_read(trace)
     call sep_write(max_loc_and_val(abs(trace),ot,dt)) 
  end do
  deallocate(trace)

end program Mpat

