program Infill

  use sep, only: sep_init, from_history, to_history, sep_close, sep_read, sep_write
  implicit none

  integer                             :: nt, n2, i
  integer, parameter                  :: cable_len=111
  real   ,  dimension(:), allocatable :: trace, zeroTrace

  call sep_init ()
  call from_history("n1", nt)
  call from_history("n2", n2)
  call to_history  ("n2", cable_len*4)
  call to_history  ("n3", 411)
  call to_history  ("o2", 0.)
  call to_history  ("o3", 2194.5601)
  call to_history  ("d2", 4.572)
  call to_history  ("d3", 4.572)
  call to_history  ("label1","time[s]")
  call to_history  ("label2","half_off[m]")
  call to_history  ("label3","cmp_x[m]")
  call sep_close ()  

  allocate(trace(nt), zeroTrace(nt)); trace=0.; zeroTrace=0.

  do i=1, n2-1
     call sep_read(trace)
     call sep_write(trace)
     if (mod(i,4*cable_len)/=0) then
        call sep_write(zeroTrace)
        call sep_write(zeroTrace)
	call sep_write(zeroTrace)
	if (mod(i,cable_len)==0) call sep_write(zeroTrace)
     end if
  end do
  
  call sep_read(trace)
  call sep_write(trace)
  call sep_write(zeroTrace)
  deallocate(trace, zeroTrace)

end program Infill
